#include "configdialog.h"
#include "ui_configdialog.h"
#include <QSettings>

ConfigDialog::ConfigDialog(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::ConfigDialog)
{
    ui->setupUi(this);
    QSettings settings("Andrey Demenev", "FlashTerm");
    settings.beginGroup("Terminal");
    ui->portName->setText(settings.value("Port").toString());
    ui->baudRate->setCurrentIndex(ui->baudRate->findText(settings.value("BaudRate").toString()));
    ui->dataBits->setCurrentIndex(ui->dataBits->findText(settings.value("DataBits").toString()));
    ui->stopBits->setCurrentIndex(ui->stopBits->findText(settings.value("StopBits").toString()));
    ui->parity->setCurrentIndex(ui->parity->findText(settings.value("Parity").toString()));
    settings.endGroup();
}

ConfigDialog::~ConfigDialog()
{
    delete ui;
}

void ConfigDialog::changeEvent(QEvent *e)
{
    QDialog::changeEvent(e);
    switch (e->type()) {
    case QEvent::LanguageChange:
        ui->retranslateUi(this);
        break;
    default:
        break;
    }
}


void ConfigDialog::accept()
{
    QSettings settings("Andrey Demenev", "FlashTerm");
    settings.beginGroup("Terminal");
    settings.setValue("Port", ui->portName->text());
    settings.setValue("BaudRate", ui->baudRate->currentText());
    settings.setValue("DataBits", ui->dataBits->currentText());
    settings.setValue("StopBits", ui->stopBits->currentText());
    settings.setValue("Parity", ui->parity->currentText());
    settings.endGroup();
    close();
}
