#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QTimer>
#include <QLabel>
#include <QProcess>
#include <qextserialport.h>

namespace Ui {
    class MainWindow;
}

class MainWindow : public QMainWindow {
    Q_OBJECT
public:
    MainWindow(QWidget *parent = 0);
    ~MainWindow();

protected:
    void changeEvent(QEvent *e);

private:
    Ui::MainWindow *ui;
    QextSerialPort *port;
    QTimer *timer;

    QString workingDir;
    QLabel *dirLabel;

    QProcess make;

private slots:
    void on_actionAbout_QT_triggered();
    void on_actionAbout_triggered();
    void on_actionClear_triggered();
    void on_actionUpload_triggered();
    void on_actionSelect_directory_triggered();
    void on_toolButton_clicked();
    void on_terminalInput_returnPressed();
    void on_actionConnect_triggered(bool checked);
    void on_actionConfig_activated();
    void timeout();
};

#endif // MAINWINDOW_H
