#include "uploaddialog.h"
#include "ui_uploaddialog.h"
#include <QProcess>

UploadDialog::UploadDialog(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::UploadDialog)
{
    ui->setupUi(this);
}

UploadDialog::~UploadDialog()
{
    delete ui;
}

void UploadDialog::changeEvent(QEvent *e)
{
    QDialog::changeEvent(e);
    switch (e->type()) {
    case QEvent::LanguageChange:
        ui->retranslateUi(this);
        break;
    default:
        break;
    }
}

void UploadDialog::upload(QString &workingDir)
{
    QStringList args;
    QProcess make;
    setModal(true);
    running = true;
    show();
    args << "program";
    make.setWorkingDirectory(workingDir);
    make.setProcessChannelMode(QProcess::MergedChannels);
    make.setReadChannel(QProcess::StandardOutput);
    make.start("make", args, QIODevice::ReadWrite);
    if (make.waitForStarted(-1)) {
        while (make.state() == QProcess::Running) {
            QApplication::processEvents(QEventLoop::ExcludeUserInputEvents);
            if (make.waitForReadyRead(50)) {
                while (make.bytesAvailable()) {
                    QByteArray bytes = make.readLine();
                    ui->plainTextEdit->insertPlainText(QString(bytes.data()));
                    ui->plainTextEdit->ensureCursorVisible();
                }
            }
        }
        running = false;
        if (make.exitCode()) {
            QTextCharFormat fmt;
            fmt.setForeground(QBrush(QColor(255,0,0),Qt::SolidPattern));
            fmt.setFontWeight(QFont::DemiBold);
            ui->plainTextEdit->setCurrentCharFormat(fmt);
            ui->plainTextEdit->insertPlainText("\n\nError\n\n");
            exec();
        }
    }
    running = false;
}

void UploadDialog::closeEvent(QCloseEvent *event)
{
    if (!running) event->accept();
}
